---------------
-- Version 1.08
---------------

local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')

local labelType = 2 -- 1 = text, 2 = icon, 3 = icon + text
local lastPanel
local displayString = "---"
local _hex
local version = GetAddOnMetadata("ElvUI_DraenorCurrencies", "Version")
local red = "|cffc74040"
local orange = "|cffda8c4f"
local Currencies = {823, 944, 980, 824, 1101, 994, 1129, 1191, 1166}
-- local state ={true, true, true, true, true, true, true, true, true} -- old way to enable/disable currency-tracking
local MAX = 9
local login = false
local advertise = false
local z = 0
local loginmsg = L["%sElvUI|r %sDraenor Currencies|r: Version %s%s|r is loaded."]

--[[ Keeping this here for reference sake
local ApexisCrystals = {823}
local ArtifactFragments = {944}
local DingyIronCoins = {980}
local GarrisonResources = {824}
local Oil = {1101}
local SealOfTemperedFate = {994}
local SealOfInevitableFate = {1129}
local Valor = {1191}
local TimewarpedBadge = {1166}
]]

V["ElvUI_DraenorCurrency"] = {
	["AC"] = true,
	["AF"] = true,
	["DIC"] = true,
	["GR"] = true,
	["Oil"] = true,
	["SoTF"] = true,
	["SoIF"] = true,
	["VR"] = true,
	["TB"] = true,
	["Icons"] = true
}

local function setupDB() 
	E.private["ElvUI_DraenorCurrency"] = E.private["ElvUI_DraenorCurrency"] or {}
--	E.private["ElvUI_DraenorCurrency"]["AC"]    = true or false
--	E.private["ElvUI_DraenorCurrency"]["AF"]    = true or false
--	E.private["ElvUI_DraenorCurrency"]["DIC"]   = true or false
--	E.private["ElvUI_DraenorCurrency"]["GR"]    = true or false
--	E.private["ElvUI_DraenorCurrency"]["Oil"]   = true or false
--	E.private["ElvUI_DraenorCurrency"]["SoTF"]  = true or false
--	E.private["ElvUI_DraenorCurrency"]["SoIF"]  = true or false
--	E.private["ElvUI_DraenorCurrency"]["VR"]    = true or false
--	E.private["ElvUI_DraenorCurrency"]["TB"]    = true or false
--	E.private["ElvUI_DraenorCurrency"]["Icons"] = true or false
--	E.private["ElvUI_DraenorCurrency"]["AC"]    = E.private["ElvUI_DraenorCurrency"]["AC"] or true
--	E.private["ElvUI_DraenorCurrency"]["AF"]    = E.private["ElvUI_DraenorCurrency"]["AF"] or true
--	E.private["ElvUI_DraenorCurrency"]["DIC"]   = E.private["ElvUI_DraenorCurrency"]["DIC"] or true
--	E.private["ElvUI_DraenorCurrency"]["GR"]    = E.private["ElvUI_DraenorCurrency"]["GR"] or true
--	E.private["ElvUI_DraenorCurrency"]["Oil"]   = E.private["ElvUI_DraenorCurrency"]["Oil"] or true
--	E.private["ElvUI_DraenorCurrency"]["SoTF"]  = E.private["ElvUI_DraenorCurrency"]["SoTF"] or true
--	E.private["ElvUI_DraenorCurrency"]["SoIF"]  = E.private["ElvUI_DraenorCurrency"]["SoIF"] or true
--	E.private["ElvUI_DraenorCurrency"]["VR"]    = E.private["ElvUI_DraenorCurrency"]["VR"] or true
--	E.private["ElvUI_DraenorCurrency"]["TB"]    = E.private["ElvUI_DraenorCurrency"]["TB"] or true
--	E.private["ElvUI_DraenorCurrency"]["Icons"] = E.private["ElvUI_DraenorCurrency"]["Icons"] or true
end

StaticPopupDialogs["ECDInfo"] = {
	text = "Draenor Currencies Datatext has a big brother;\nElvui Currencies Datatext!\n \nThis new addon will do all the functions Draenor Currencies Datatext does, but for ALL your currencies, and more!\nAlso includes localization-support for:\nGerman, French, Italian, Spanish and Portuguese!\n \nYou will find this addon at:",
	button1 = L["Okay"],
	hasEditBox = 1,
	maxLetters = 120,
	editBoxWidth = 350,
	OnShow = function (self, data)
		self.editBox:SetText("http://www.curse.com/addons/wow/elvui-currencies-datatext")
		self.editBox:SetFocus()
		self.editBox:HighlightText()
	end,
	OnAccept = function() StaticPopup_Hide(self) end,
	hasEditBox = true,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	preferredIndex = 3,
}

local function ToggleOption(name)
	if E.private["ElvUI_DraenorCurrency"][name] then
		E.private["ElvUI_DraenorCurrency"][name] = false
	else
		E.private["ElvUI_DraenorCurrency"][name] = true
	end
end

local function GetOption(name)
	if E.private["ElvUI_DraenorCurrency"] then
		return E.private["ElvUI_DraenorCurrency"][name]
	end
end

local menu = {
	{ text = L["ElvUI Draenor Currencies Options"], isTitle = true , notCheckable = true },
	{ text = L["Show Apexis Crystals"], checked = function() return GetOption('AC') end, func = function() ToggleOption('AC') end },
	{ text = L["Show Artifact Fragments"], checked = function()  return GetOption('AF') end, func = function() ToggleOption('AF') end },
	{ text = L["Show Dingy Iron Coins"], checked = function() return GetOption('DIC') end, func = function() ToggleOption('DIC') end },
	{ text = L["Show Garrison Resources"], checked = function() return GetOption('GR') end, func = function() ToggleOption('GR') end },
	{ text = L["Show Oil"], checked = function() return GetOption('Oil') end, func = function() ToggleOption('Oil') end },
	{ text = L["Show Seal of Tempered Fate"], checked = function() return GetOption('SoTF') end, func = function() ToggleOption('SoTF') end },
	{ text = L["Show Seal of Inevitable Fate"], checked = function() return GetOption('SoIF') end, func = function() ToggleOption('SoIF') end },
	{ text = L["Show Valor"], checked = function() return GetOption('VR') end, func = function() ToggleOption('VR') end },
	{ text = L["Show Timewarped Badge"], checked = function() return GetOption('TB') end, func = function() ToggleOption('TB') end },
	{ text = L["Show icons"], checked = function() return GetOption('Icons') end, func = function() ToggleOption('Icons') end },
	{ text = "  ", isTitle = true, notCheckable = true },
	{ text = L["New Addon: ElvUI Currencies DT. Click for info."], notCheckable = true, func = function() StaticPopup_Show("ECDInfo") end },
}

local menuFrame = CreateFrame("Frame", "ElvUI_DraenorCurrencyMenuFrame", E.UIParent, 'UIDropDownMenuTemplate')

local function getCurrenyCap(name)
	local cap = 0
	if name == L["Apexis Crystal"] then cap = 0
	elseif name == L["Artifact Fragment"] then cap = 1000
	elseif name == L["Dingy Iron Coins"] then cap = 20000
	elseif name == L["Garrison Resources"] then cap = 10000
	elseif name == L["Oil"] then cap = 100000
	elseif name == L["Seal of Tempered Fate"] then cap = 20
	elseif name == L["Seal of Inevitable Fate"] then cap = 10
	elseif name == L["Valor"] then cap = 5000
	elseif name == L["Timewarped Badge"] then cap = 0
	else cap = 0
	end
	return cap
end

local function ColorValue(name, currency)
	local color
	local cap = getCurrenyCap(name)
	local percent = currency * (100 / cap)
	
	if percent < 70 then color = _hex
	elseif percent >= 70 and percent < 90 then color = orange
	elseif percent >= 90 then color = red
	end

	if cap == 0 then return _hex
	else return color
	end
end



local function OnEvent(self, event, ...)
	setupDB()
	lastPanel = self
	if event == PLAYER_ENTERING_WORLD and not login then
		DEFAULT_CHAT_FRAME:AddMessage(format(loginmsg, "|cff1784d1", "|cffded181", ColorValue("Title", 0, 0), version))
		login = true
	end
	
	z = z+1
	if not advertise  and z >= 25 then
		DEFAULT_CHAT_FRAME:AddMessage(format("%sElvUI|r Draenor %sCurrencies|r: My big brother has arrived, doing the same as me but for all your currencies! For more info checkout %s[|Hurl:http://mods.curse.com/addons/wow/elvui-currencies-datatext|hhttp://mods.curse.com/addons/wow/elvui-currencies-datatext|h]|r.", "|cff1784d1", ColorValue("Title", 0, 0), "|cffded181"))
		advertise = true
	end
		
	local _text = "---"
	if not _hex then return end
	
	for i = 1, MAX do
		if i == 1 then 
			displayString = '' 
		end
		local index = Currencies[i]
		local name, count, icon, earnedThisWeek, weeklyMax, totalMax, isDiscovered = GetCurrencyInfo(index)
		if name and isDiscovered then
			if name == L["Apexis Crystal"] and GetOption('AC') then
				if(i ~= 1) then _text = "  " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,1)
				end
				local str
				if not GetOption('Icons') then
					str = tostring(_text..":".._hex..count.."|r")
				elseif GetOption('Icons') then
					str = tostring(texture..":"..ColorValue(name, count)..count.._hex.."|r  ")
				end
				displayString = displayString..str
			end
			if name == L["Artifact Fragment"] and GetOption('AF') then
				if(i ~= 1) then _text = "  " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,1)
				end
				local str
				if not GetOption('Icons') then
					str = tostring(_text..":".._hex..count.."|r")
				elseif GetOption('Icons') then
					str = tostring(texture..":"..ColorValue(name, count)..count.._hex.."|r  ")
				end
				displayString = displayString..str
			end
			if name == L["Dingy Iron Coins"] and GetOption('DIC') then
				if(i ~= 1) then _text = "  " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,1)
				end
				local str
				if not GetOption('Icons') then
					str = tostring(_text..":".._hex..count.."|r")
				elseif GetOption('Icons') then
					str = tostring(texture..":"..ColorValue(name, count)..count.._hex.."|r  ")
				end
				displayString = displayString..str
			end
			if name == L["Garrison Resources"] and GetOption('GR') then
				if(i ~= 1) then _text = "  " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,1)
				end
				local str
				if not GetOption('Icons') then
					str = tostring(_text..":".._hex..count.."|r")
				elseif GetOption('Icons') then
					str = tostring(texture..":"..ColorValue(name, count)..count.._hex.."|r  ")
				end
				displayString = displayString..str
			end
			if name == L["Oil"] and GetOption('Oil') then
				if(i ~= 1) then _text = "  " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,1)
				end
				local str
				if not GetOption('Icons') then
					str = tostring(_text..":".._hex..count.."|r")
				elseif GetOption('Icons') then
					str = tostring(texture..":"..ColorValue(name, count)..count.._hex.."|r  ")
				end
				displayString = displayString..str
			end
			if name == L["Seal of Tempered Fate"] and GetOption('SoTF') then
				if(i ~= 1) then _text = "  " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,1)
				end
				local str
				if not GetOption('Icons') then
					str = tostring(_text..":".._hex..count.."|r")
				elseif GetOption('Icons') then
					str = tostring(texture..":"..ColorValue(name, count)..count.._hex.."|r  ")
				end
				displayString = displayString..str
			end
			if name == L["Seal of Inevitable Fate"] and GetOption('SoIF') then
				if(i ~= 1) then _text = "  " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,1)
				end
				local str
				if not GetOption('Icons') then
					str = tostring(_text..":".._hex..count.."|r")
				elseif GetOption('Icons') then
					str = tostring(texture..":"..ColorValue(name, count)..count.._hex.."|r  ")
				end
				displayString = displayString..str
			end
			if name == L["Valor"] and GetOption('VR') then
				if(i ~= 1) then _text = "  " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,1)
				end
				local str
				if not GetOption('Icons') then
					str = tostring(_text..":".._hex..count.."|r")
				elseif GetOption('Icons') then
					str = tostring(texture..":"..ColorValue(name, count)..count.._hex.."|r  ")
				end
				displayString = displayString..str
			end
			if name == L["Timewarped Badge"] and GetOption('TB') then
				if(i ~= 1) then _text = "  " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,1)
				end
				local str
				if not GetOption('Icons') then
					str = tostring(_text..":".._hex..count.."|r")
				elseif GetOption('Icons') then
					str = tostring(texture..":"..ColorValue(name, count)..count.._hex.."|r  ")
				end
				displayString = displayString..str
			end
--[[ part of old script, keeping this here in case it might still come in handy
				if(i ~= 1) then _text = " " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,1)
				end
				local str
				if labelType == 1 then
					str = tostring(_text..": ".._hex..count.."|r")
				elseif labelType == 2 then
					str = tostring(texture..":"..ColorValue(name, count)..count.._hex.."|r  ")
				elseif labelType == 3 then
					str = tostring(texture.." ".._text..": ".._hex..count.."|r")
				end
				displayString = displayString..str
]]

		elseif i == 1 and not name and not count then 
			displayString = tostring(_hex.."---")
		end
	end
	if displayString == '' or (not GetOption(L["AC"]) and not GetOption(L["AF"]) and not GetOption(L["DIC"]) and not GetOption(L["GR"]) and not GetOption(L["Oil"]) and not GetOption(L["SoIF"]) and not GetOption(L["SoTF"]) and not GetOption(L["VR"]) and not GetOption(L["TB"])) then 
		displayString = tostring("ElvUI "..ColorValue("Title", 0).."Draenor "..L["Currencies"].._hex.."|r") -- Lang.. " - 
--		self.text:SetFormattedText(displayString)
	end	

	if self then 
		self.text:SetFormattedText(displayString)
	end
	displayString = "---"

end

local function OnEnter(self)
	local r1, g1, b1, r2, g2, b2 = HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b;
	DT:SetupTooltip(self)
	DT.tooltip:AddDoubleLine("Right-Click:", "Opens Datatext Options Menu", r1, g1, b1, r2, g2, b2)
	if lastPanel ~= nil then
		OnEvent(lastPanel)
	end
	DT.tooltip:Show()
end

local function OnClick(self, btn)
	if btn == "RightButton" then
		DT.tooltip:Hide();
		EasyMenu(menu, menuFrame, self, 0, 120, 'MENU', 3)
	end
end

local function ValueColorUpdate(hex, r, g, b)
	_hex = hex
	if lastPanel ~= nil then
		OnEvent(lastPanel)
	end
end
E['valueColorUpdateFuncs'][ValueColorUpdate] = true

--[[
	DT:RegisterDatatext(name, events, eventFunc, updateFunc, clickFunc, onEnterFunc)

	name - name of the datatext (required)
	events - must be a table with string values of event names to register
	eventFunc - function that gets fired when an event gets triggered
	updateFunc - onUpdate script target function
	click - function to fire when clicking the datatext
	onEnterFunc - function to fire OnEnter
]]
DT:RegisterDatatext('DraenorCurrencies', {'PLAYER_LOGIN', 'PLAYER_ENTERING_WORLD', 'PLAYER_MONEY', 'PLAYER_TRADE_MONEY', 'TRADE_MONEY_CHANGED', 'SPELLS_CHANGED'}, OnEvent, nil, OnClick, OnEnter) hooksecurefunc("BackpackTokenFrame_Update", function(...) OnEvent(lastPanel) end)
